///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------


#pragma hdrstop

#include "MobFormat.h"
#include "MobObjectObj.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

///////////////////////////////////
//TUnitObjBlock
///////////////////////////////////

DWORD TObjectObjBlock::GetBlockSize()
//       .
{
  //...
  DWORD Result = 203;
  int i;
  //203 -  .

  //...
  //   ...
  Result = Result + ScriptVariableName.Length() + ModelName.Length() + Name2.Length()
  + FirstTexture.Length() + SecondTexture.Length() + UnknownStr1.Length()
  + QuestLightStr.Length();

  //  ...

  //Result = Result + 12;
  for (i = 0; i < BodyTextures->Length; i++)
  {
    Result = Result + BodyTextures->operator[](i).Length() + 8;
  };

  return Result;
};

bool TObjectObjBlock::ReadBlock(byte *Buff, DWORD BuffSize, bool UseLog, TMob *PMobObj)
//     .
{
  // ...
  DWORD TempDW1, MinBlockSgn, MinBlockSize, TempDW2, i;
  bool Result = true;
  __int64 Cursor = 8;

  //    .
  do
  {
    //  ...
    memcpy(&MinBlockSgn,&Buff[Cursor],4);
    Cursor = Cursor+4;
    //     ...
    if (MinBlockSgn == Obj_Sgn_BodyTextures)
    {
      // 
      //DynamicArray <String>

      //   .
     BodyTextures = new DynamicArray <String>;

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      //  
      memcpy(&TempDW1,&Buff[Cursor],4);
      Cursor = Cursor+4;

      if (TempDW1 != 0)
      {
        //  ...
        // ...
        BodyTextures->Length = TempDW1;
        i = -1;
        do
        {
          //   ...
          TempDW1 = TempDW1-1; //  -        
          i = i+1;

          Cursor = Cursor+4;  // 

          //  ...
          memcpy(&TempDW2,&Buff[Cursor],4);
          Cursor = Cursor+4;

          // ...
          if ((TempDW2 - 8) != 0)
          {
            BodyTextures->operator[](i).SetLength((TempDW2 - 8));
            memcpy(&BodyTextures->operator[](i)[1],&Buff[Cursor],(TempDW2 - 8));
            Cursor = Cursor+(TempDW2 - 8);
          }
          else
          {
            BodyTextures->operator[](i) = "";
          };
        }
        while (TempDW1 != 0);
      }
      else
      {
        //  ...
        BodyTextures->Length = 0;
      };
    }


    else if (MinBlockSgn == Obj_Sgn_PlayerNumber)
    {
      // .
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&PlayerNumber,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }


    else if (MinBlockSgn == Obj_Sgn_ObjectID)
    {
      //ID .
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ObjectID,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }


    else if (MinBlockSgn == Obj_Sgn_ObjectType)
    {
      // .
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ObjectType,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }


    else if (MinBlockSgn == Obj_Sgn_ScriptVariableName)
    {
      //   .     .
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      ScriptVariableName.SetLength(MinBlockSize-8);

      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&ScriptVariableName[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        ScriptVariableName = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_ModelName)
    {
      // 3-.
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      ModelName.SetLength(MinBlockSize-8);

      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&ModelName[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        ModelName = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_Name2)
    {
      //     .
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      Name2.SetLength(MinBlockSize-8);
      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&Name2[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        Name2 = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_FirstTexture)
    {
      //  (  ).
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      FirstTexture.SetLength(MinBlockSize-8);
      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&FirstTexture[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        FirstTexture = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_SecondTexture)
    {
      //  (  ,  default0).
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;
      SecondTexture.SetLength(MinBlockSize-8);
      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&SecondTexture[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        SecondTexture = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_UnknownStr1)
    {
      // .   none.
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      UnknownStr1.SetLength(MinBlockSize-8);
      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&UnknownStr1[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        UnknownStr1 = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_LoadCoords)
    {
      // .
      //float X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&LoadX,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&LoadY,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&LoadZ,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Obj_Sgn_Rotation)
    {
      // .
      //float X 4

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&RotationW,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&RotationX,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&RotationY,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&RotationZ,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Obj_Sgn_IsQuestUnit)
    {
      //    .
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&IsQuestUnit,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Obj_Sgn_UncnByte1)
    {
      //   1 .
      //byte

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnByte1,&Buff[Cursor],1);
      Cursor = Cursor+1;
    }

    else if (MinBlockSgn == Obj_Sgn_UncnDw2)
    {
      // dw.
      //DWORD

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&UncnDw2,&Buff[Cursor],4);
      Cursor = Cursor+4;
    }

    else if (MinBlockSgn == Obj_Sgn_QuestLightStr)
    {
      //-    .
      //String

      //  ...
      memcpy(&MinBlockSize,&Buff[Cursor],4);
      Cursor = Cursor+4;

      QuestLightStr.SetLength(MinBlockSize-8);
      // ...
      if ((MinBlockSize-8) != 0)
      {
        memcpy(&QuestLightStr[1],&Buff[Cursor],(MinBlockSize-8));
        Cursor = Cursor+(MinBlockSize-8);
      }
      else
      {
        QuestLightStr = "";
      };
    }

    else if (MinBlockSgn == Obj_Sgn_Complection)
    {
      //
      //float X 3

      //  ...
      Cursor = Cursor+4;
      // ...
      memcpy(&ComplectionStrength,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&ComplectionDex,&Buff[Cursor],4);
      Cursor = Cursor+4;
      memcpy(&ComplectionTall,&Buff[Cursor],4);
      Cursor = Cursor+4;
    };


  }
  while (Cursor != BuffSize);

  StopLoadUnitBlock:        //     .
  ;
  return Result;
};

void TObjectObjBlock::GenBasePart(byte *Result)
//   ...
{
  //
  int i = 0; //
  DWORD ChetireBaita, BlockSignature;
  DWORD Cursor = 0;
  
  // 
  //DynamicArray <String>
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_BodyTextures,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 0;
  for (i = 0; i < BodyTextures->Length; i++)
  {
    ChetireBaita = ChetireBaita + BodyTextures->operator[](i).Length() + 8;
  };
  ChetireBaita = ChetireBaita + 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //   ...
  ChetireBaita = BodyTextures->Length;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  // ...
  for (i = 0; i < BodyTextures->Length; i++)
  {
    // 
    memcpy(&Result[Cursor],&Obj_Sgn_BodyTextures,4);
    Cursor = Cursor+4;
    // ...
    ChetireBaita = 8+BodyTextures->operator[](i).Length();
    memcpy(&Result[Cursor],&ChetireBaita,4);
    Cursor = Cursor+4;
    //...
    if (BodyTextures->operator[](i).Length() > 0)
    {
      memcpy(&Result[Cursor],&BodyTextures->operator[](i)[1],BodyTextures->operator[](i).Length());
      Cursor = Cursor+BodyTextures->operator[](i).Length();
    };  
  };

  // .
  //byte
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_PlayerNumber,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&PlayerNumber,1);
  Cursor = Cursor+1;

  //ID .
  //DWORD
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_ObjectID,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ObjectID,4);
  Cursor = Cursor+4;

  // .
  //DWORD
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_ObjectType,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ObjectType,4);
  Cursor = Cursor+4;

  //   .     .
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_ScriptVariableName,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+ScriptVariableName.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&ScriptVariableName[1],ScriptVariableName.Length());
    Cursor = Cursor+ScriptVariableName.Length();
  };  

  // 3-.
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_ModelName,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+ModelName.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&ModelName[1],ModelName.Length());
    Cursor = Cursor+ModelName.Length();
  };  

  //     .
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_Name2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+Name2.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&Name2[1],Name2.Length());
    Cursor = Cursor+Name2.Length();
  };  

  //  (  ).
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_FirstTexture,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+FirstTexture.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&FirstTexture[1],FirstTexture.Length());
    Cursor = Cursor+FirstTexture.Length();
  };  

  //  (  ,  default0).
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_SecondTexture,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+SecondTexture.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&SecondTexture[1],SecondTexture.Length());
    Cursor = Cursor+SecondTexture.Length();
  };  

  // .   none.
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_UnknownStr1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+UnknownStr1.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&UnknownStr1[1],UnknownStr1.Length());
    Cursor = Cursor+UnknownStr1.Length();
  };  

  // .
  //float X 3
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_LoadCoords,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&LoadX,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&LoadY,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&LoadZ,4);
  Cursor = Cursor+4;

  // .
  //float X 4
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_Rotation,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 24;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&RotationW,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&RotationX,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&RotationY,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&RotationZ,4);
  Cursor = Cursor+4;

  //    .
  //byte
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_IsQuestUnit,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&IsQuestUnit,1);
  Cursor = Cursor+1;

  //   1 .
  //byte
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_UncnByte1,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 9;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnByte1,1);
  Cursor = Cursor+1;

  // dw.
  //DWORD
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_UncnDw2,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 12;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&UncnDw2,4);
  Cursor = Cursor+4;

  //-    .
  //String
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_QuestLightStr,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 8+QuestLightStr.Length();
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //...
  if (ChetireBaita > 8)
  {
    memcpy(&Result[Cursor],&QuestLightStr[1],QuestLightStr.Length());
    Cursor = Cursor+QuestLightStr.Length();
  };

  //
  //float X 3
  // 
  memcpy(&Result[Cursor],&Obj_Sgn_Complection,4);
  Cursor = Cursor+4;
  // ...
  ChetireBaita = 20;
  memcpy(&Result[Cursor],&ChetireBaita,4);
  Cursor = Cursor+4;
  //
  memcpy(&Result[Cursor],&ComplectionStrength,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&ComplectionDex,4);
  Cursor = Cursor+4;
  memcpy(&Result[Cursor],&ComplectionTall,4);
  Cursor = Cursor+4;
};

byte* TObjectObjBlock::GenBlock(DWORD& BlockSize)
// ...
{
  //
  byte* Result = NULL;
  DWORD Cursor = 0;

  //, .      ...
  BlockSize = GetBlockSize();
  Result = new byte[BlockSize];

  // ...
  memcpy(&Result[Cursor],&OB_Sgn_Object,4);
  Cursor = Cursor+4;

  // .
  memcpy(&Result[Cursor],&BlockSize,4);
  Cursor = Cursor+4;

  //    ...
  GenBasePart(&Result[Cursor]);

  //  ...
  return Result;
};
