///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "OrientatorFrame.h"
#include "MainForm.h"
#include "initer.h"
/*#include "MobParticle1Obj.h"
#include "MobParticle2Obj.h"
#include "MobParticle3Obj.h"*/

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOrientatorFr *OrientatorFr;
//---------------------------------------------------------------------------

__fastcall TOrientatorFr::TOrientatorFr(TComponent* Owner)
        : TFrame(Owner)
{
  // ...

  // ....
  ObjectQuat = new TQuaternion(1,0,0,0);  //     %)

  //     ...
  OldMouseX = 0;
  OldMouseY = 0;
  OldMouseShift.Clear();
  WheelSkipCounter = 3;
  OrientationChanged = false;

}
//---------------------------------------------------------------------------

__fastcall TOrientatorFr::~TOrientatorFr()
{
  // ...

  // ...
  delete ObjectQuat;
}
//---------------------------------------------------------------------------


bool TOrientatorFr::bSetupPixelFormat(HDC hdc)
//  
{
    PIXELFORMATDESCRIPTOR pfd, *ppfd;
    int pixelformat;
 
    ppfd = &pfd;
 
    ppfd->nSize = sizeof(PIXELFORMATDESCRIPTOR);
    ppfd->nVersion = 1;
    ppfd->dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
    ppfd->dwLayerMask = PFD_MAIN_PLANE;
    ppfd->iPixelType = PFD_TYPE_RGBA;
    ppfd->cColorBits = 16;
    ppfd->cDepthBits = 16;
 
    ppfd->cAccumBits = 0;
    ppfd->cStencilBits = 0;
 
    if ((pixelformat = ChoosePixelFormat(hdc, ppfd)) == 0)
    {
        MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);
        return FALSE;
    }
    if (SetPixelFormat(hdc, pixelformat, ppfd) == FALSE)
    {
        MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);
        return FALSE;
    }
    return TRUE;
};
//---------------------------------------------------------------------------

void TOrientatorFr::Draw()
// OpenGL- 
{
  //...
  GLUquadricObj *quadObj;
  quadObj = gluNewQuadric();   //        .

  glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

  // %).
  //1) .
  glLineWidth(3);    //  .
  glBegin(GL_LINES);
    // X
    glColor3d(1,0,0);
    glVertex3d(4,0,0);
    glVertex3d(0,0,0);
    // Y
    glColor3d(0,1,0);
    glVertex3d(0,4,0);
    glVertex3d(0,0,0);
    // Z
    glColor3d(0,0,1);
    glVertex3d(0,0,4);
    glVertex3d(0,0,0);
  glEnd();
  //2)   ...
  //  -    ....
  //  ...
  this->ObjectQuat->GetGLMatrix(this->WorkMatrix);
  //  ...
  glPushMatrix();
  //  ...
  glLoadMatrixf(this->WorkMatrix);
  // ...
  //...
  glLineWidth(6);    //  .
  glBegin(GL_LINES);
    glColor3d(1,1,1);
    glVertex3d(1.5,0,0);
    glVertex3d(0,0,0);
    glVertex3d(0,-1.5,0);
    glVertex3d(0,0,0);
    glVertex3d(0,0,1);
    glVertex3d(0,0,0);
  glEnd();
  // 
  //1)   X...
  //  ...
  glPushMatrix();
    //  X  2...
    glTranslatef(2,0,0);
    gluQuadricDrawStyle(quadObj, GLU_FILL);   // - ...
    gluSphere(quadObj,0.5, 10, 10);   // ...
  //   ...
  glPopMatrix();
  //2)   Y...
  //  ...
  glPushMatrix();
    //  Y  -1.5...
    glTranslatef(0,-1.5,0);
    //      y...
    glRotatef(90,1,0,0);
    gluCylinder(quadObj, 0.5, 0, 1, 15, 15);
  //   ...
  glPopMatrix();

  //   ...
  glPopMatrix();

  gluDeleteQuadric(quadObj);  //    %)

  //glRotatef(1,0,1,0);  //  -   -        ...
  SwapBuffers(ghDC);
};
//---------------------------------------------------------------------------

void TOrientatorFr::GLInitialize()
// OGL
{
  ghDC = GetDC(Handle);
  /*if (!bSetupPixelFormat(ghDC))
    Close();*/
  this->bSetupPixelFormat(ghDC);

  ghRC = wglCreateContext(ghDC);
  wglMakeCurrent(ghDC, ghRC);
 
  glClearColor(0.0, 0.0, 0.0, 0.0);
 
  FrameResize(this);
 
  glEnable(GL_COLOR_MATERIAL);
  glEnable(GL_DEPTH_TEST);
 
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  float p[4]={4,4,4,1},   // 
        d[3]={0,0,0},     //
        a[4]={0.4,0.4,0.4,1};   //  RGBA

  //float p[4]={3,1,1,1},
  //      d[3]={-1,-1,-3};
  glLightfv(GL_LIGHT0,GL_POSITION,p);
  glLightfv(GL_LIGHT0,GL_SPOT_DIRECTION,d);
  glLightfv(GL_LIGHT0,GL_AMBIENT,a);

  glPushMatrix();
};
//---------------------------------------------------------------------------

void TOrientatorFr::GLDeInitialize()
// OGL
{
  if(ghRC)
  {
    wglMakeCurrent(ghDC,0);
    wglDeleteContext(ghRC);
  }
  if(ghDC)
    ReleaseDC(Handle, ghDC);
};
//---------------------------------------------------------------------------
void __fastcall TOrientatorFr::FrameResize(TObject *Sender)
{
  glViewport( 0, 0, Width, Height );
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  glOrtho(-5,5, -5,5, 2,12);
  //glOrtho(-5,5, -5,5, 2,12);
  gluLookAt(1,-5,5, 0,0,0, 0,0,1);
  glMatrixMode( GL_MODELVIEW );
}              
//---------------------------------------------------------------------------


void __fastcall TOrientatorFr::RedrawTTimer(TObject *Sender)
{
  if (MainF->MainF_PK->ActivePage == MainF->ObjectsSh)
  {
    //     %)
    Draw();
  };
}
//---------------------------------------------------------------------------

void __fastcall TOrientatorFr::FrameMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
  //
    GLdouble vx,vy,vz;       //       viewport-a.
    GLdouble wx1,wy1,wz1,
             wx2,wy2,wz2,
             wx3,wy3,wz3,
             wx4,wy4,wz4;       //   .

  //  ,     -   ...
  this->SetFocus();

  //      %).
  if ( (Shift.Contains(ssLeft) == true) && (Shift.Contains(ssCtrl)) )
  {
    //    c ...
    //       ...
    if ( (OldMouseShift.Contains(ssLeft) == true) && (OldMouseShift.Contains(ssCtrl)) )
    {
      //.      %).

      //      ...
      //    ""

      glGetIntegerv(GL_VIEWPORT,viewport);           //   viewport-a.
      glGetDoublev(GL_PROJECTION_MATRIX,ProjectionMatrix); //   .
      glGetDoublev(GL_MODELVIEW_MATRIX,ModelviewMatrix);   //   .

      //  ...
      vx = OldMouseX;
      vy = Height - OldMouseY - 1;
      vz = 0;
      gluUnProject(vx, vy, vz, ModelviewMatrix, ProjectionMatrix, viewport, &wx1, &wy1, &wz1);
      //  ...
      vx = X;
      vy = Height - Y - 1;
      //vz = 0;      // -  .
      gluUnProject(vx, vy, vz, ModelviewMatrix, ProjectionMatrix, viewport, &wx2, &wy2, &wz2);

      //  %).
      glMatrixMode( GL_PROJECTION );
      glTranslatef(wx2-wx1,wy2-wy1,wz2-wz1);
      glMatrixMode( GL_MODELVIEW );

      /*glMatrixMode( GL_PROJECTION );
      glTranslatef(float(Y-OldMouseY)/16,float(X-OldMouseX)/16,0);
      glMatrixMode( GL_MODELVIEW );*/
    };
  }
  else if ( (Shift.Contains(ssRight) == true) && (Shift.Contains(ssCtrl)) )
  {
    //     ...
    //       ...
    if ( (OldMouseShift.Contains(ssRight) == true) && (OldMouseShift.Contains(ssCtrl)) )
    {
      //.      %).
      //vec3

      // .   2 .  ,  
      //      .    
      //   %).

      glGetIntegerv(GL_VIEWPORT,viewport);           //   viewport-a.
      glGetDoublev(GL_PROJECTION_MATRIX,ProjectionMatrix); //   .
      glGetDoublev(GL_MODELVIEW_MATRIX,ModelviewMatrix);   //   .

      //  ...
      //
      vx = Width / 2;
      vy = Height;  // ...   - 
      vz = 0;
      gluUnProject(vx, vy, vz, ModelviewMatrix, ProjectionMatrix, viewport, &wx1, &wy1, &wz1);
      //
      vx = Width / 2;
      vy = 0;
      vz = 0;
      gluUnProject(vx, vy, vz, ModelviewMatrix, ProjectionMatrix, viewport, &wx2, &wy2, &wz2);

      //  ...
      //
      vx = Width;
      vy = Height / 2;
      vz = 0;
      gluUnProject(vx, vy, vz, ModelviewMatrix, ProjectionMatrix, viewport, &wx3, &wy3, &wz3);
      //
      vx = 0;
      vy = Height / 2;
      vz = 0;
      gluUnProject(vx, vy, vz, ModelviewMatrix, ProjectionMatrix, viewport, &wx4, &wy4, &wz4);

      //..
      glMatrixMode( GL_PROJECTION );
      glRotatef(float(X-OldMouseX),wx1-wx2,wy1-wy2,wz1-wz2);
      glRotatef(float(Y-OldMouseY),wx3-wx4,wy3-wy4,wz3-wz4);
      glMatrixMode( GL_MODELVIEW );
    };
  };

  //   -      %)
  this->OldMouseX = X;
  this->OldMouseY = Y;
  OldMouseShift = Shift;
}
//---------------------------------------------------------------------------


void __fastcall TOrientatorFr::FrameMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
  //    -    .
  if (Shift.Contains(ssMiddle) == true)
  {
    if (Shift.Contains(ssCtrl) == true)
    {
      //  ...
      FrameResize(Sender);
    }
    else if (Shift.Contains(ssShift) == true)
    {
      //      ...
      this->ObjectQuat->QuatW = MainF->OldQuat->QuatW;
      this->ObjectQuat->QuatX = MainF->OldQuat->QuatX;
      this->ObjectQuat->QuatY = MainF->OldQuat->QuatY;
      this->ObjectQuat->QuatZ = MainF->OldQuat->QuatZ;
      this->SaveInfo();  // .
    }
    else
    {
      //  -  ...
      this->ObjectQuat->ident();
      this->SaveInfo();   //     ...
    };
  };
}
//---------------------------------------------------------------------------

void __fastcall TOrientatorFr::FrameMouseWheel(TObject *Sender,
      TShiftState Shift, int WheelDelta, TPoint &MousePos, bool &Handled)
{
  //   .
  if (WheelSkipCounter == 3)
  {
    //     4   1  
    //  .    Shift    1-
    //.     %).      
    //   .
    
    if (Shift.Empty())
    {
      //   .     Z.
      ObjectQuat->RotateByAxisAngle(0,0,1,(float)(WheelDelta) / 3500);
    }
    else if (Shift.Contains(ssRight))
    {
      // c  .     X.
      ObjectQuat->RotateByAxisAngle(1,0,0,(float)(WheelDelta) / 3500);
    }
    else if (Shift.Contains(ssLeft))
    {
      // c  .     Y.
      ObjectQuat->RotateByAxisAngle(0,1,0,(float)(WheelDelta) / 3500);
    };

    // ...
    this->ObjectQuat->normalize();

    //      ...
    this->SaveInfo();

    //   -  .
    WheelSkipCounter --;
  }
  else
  {
    //""  -  .
    if (WheelSkipCounter != 0)
    {
       WheelSkipCounter --;
    }
    else
    {
      WheelSkipCounter = 3;  //   .
    };
  };

}
//---------------------------------------------------------------------------

void TOrientatorFr::SaveInfo()
//      .
{
  if ( MainF->ObjectsTree->Selected != NULL)
  {
    //  -  - ...
    if (MainF->ObjectsTree->Selected->Parent != NULL) {
      // -    ...
      if ( ( MainF->ObjectsTree->Selected->Parent->Data != &MainF->ObjTree_Particles1Node ) &&
           ( MainF->ObjectsTree->Selected->Parent->Data != &MainF->ObjTree_Particles2Node ) &&
           ( MainF->ObjectsTree->Selected->Parent->Data != &MainF->ObjTree_Particles3Node ) )
      {
        // -     -     ,    
        //...    ...

        //  ...
        PObjectObjBlock(MainF->ObjectsTree->Selected->Data)->RotationW = this->ObjectQuat->QuatW;
        PObjectObjBlock(MainF->ObjectsTree->Selected->Data)->RotationX = this->ObjectQuat->QuatX;
        PObjectObjBlock(MainF->ObjectsTree->Selected->Data)->RotationY = this->ObjectQuat->QuatY;
        PObjectObjBlock(MainF->ObjectsTree->Selected->Data)->RotationZ = this->ObjectQuat->QuatZ;
        OrientationChanged = true;  //       .

        //    .
        MainF->SetMobModified();

      };
    };
  };
};
//---------------------------------------------------------------------------
void __fastcall TOrientatorFr::EditorUpdaterTTimer(TObject *Sender)
{
  if (MainF->MainF_PK->ActivePage == MainF->ObjectsSh)
  {
    //    %)
    if (OrientationChanged == true)
    {
      //     ...
      OrientationChanged = false;
      MainF->ValuesEditor->Values["RotationW"] = FloatToStr(this->ObjectQuat->QuatW);
      MainF->ValuesEditor->Values["RotationX"] = FloatToStr(this->ObjectQuat->QuatX);
      MainF->ValuesEditor->Values["RotationY"] = FloatToStr(this->ObjectQuat->QuatY);
      MainF->ValuesEditor->Values["RotationZ"] = FloatToStr(this->ObjectQuat->QuatZ);
    };
  };
}
//---------------------------------------------------------------------------

