///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

//---------------------------------------------------------------------------
#ifndef OrientatorFrameH
#define OrientatorFrameH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>

#include <GL/gl.h>
#include <GL/glu.h>

#include "glQuaternions.h"
//---------------------------------------------------------------------------
class TOrientatorFr : public TFrame
{
__published:	// IDE-managed Components
        TTimer *RedrawT;
        TTimer *EditorUpdaterT;
        void __fastcall FrameResize(TObject *Sender);
        void __fastcall RedrawTTimer(TObject *Sender);
        void __fastcall FrameMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
        void __fastcall FrameMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FrameMouseWheel(TObject *Sender, TShiftState Shift,
          int WheelDelta, TPoint &MousePos, bool &Handled);
        void __fastcall EditorUpdaterTTimer(TObject *Sender);
private:	// User declarations
        HGLRC ghRC;
        HDC   ghDC;
        int WheelSkipCounter;
public:		// User declarations
        // 
        TQuaternion *ObjectQuat;   //    -.
        GLfloat WorkMatrix[16];    //  .
        GLdouble ModelviewMatrix[16];    //  .
        GLdouble ProjectionMatrix[16];    //  .
        GLint viewport[4];       //  ...
        bool OrientationChanged;  //     ...

        //""  ...
        int OldMouseX;
        int OldMouseY;
        TShiftState OldMouseShift;

        // 
        __fastcall TOrientatorFr(TComponent* Owner);
        __fastcall ~TOrientatorFr();

        //OpenGL
        bool bSetupPixelFormat(HDC hdc);   //  
        void GLInitialize();      // OGL
        void GLDeInitialize();    // OGL
        void Draw();    // OpenGL- 

        // ...    %).
        void SaveInfo();   //      .
};
//---------------------------------------------------------------------------
extern PACKAGE TOrientatorFr *OrientatorFr;
//---------------------------------------------------------------------------
#endif
