///////////////////////////////////////////////////////////
//                      MobSurgeon                       //
//           mob-            //
//           Copyright (C) 2005-2007 Gipat Group         //
//                             //
//    Gipat Group's opened EI-editor-utility license     //
//                       1.0                       //
//                                                       //
//                  www.gipatgroup.org                   //
///////////////////////////////////////////////////////////

//      , ....  :
// 1) Sagrer (sagrer@yandex.ru)

////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////
//                      //
//             OpenGL           //
//                  ver 0.1                    //
//                                             //
//             crafted by Sagrer               //
/////////////////////////////////////////////////

//---------------------------------------------------------------------------

#ifndef glQuaternionsH
#define glQuaternionsH

#include <Classes.hpp>

#include <GL/gl.h>
#include <GL/glu.h>

#include "math.h"
//#include "math.hpp"
#include "mathlib.h"

//, , ...

// 2
//class TVec2


//
class TQuaternion
{
  public:
    //...
    float QuatW;
    float QuatX;
    float QuatY;
    float QuatZ;

    //...
    //-...
    virtual ~TQuaternion();     //
    TQuaternion();     // 
    TQuaternion(float &w, float &x, float &y, float &z);  //   
    TQuaternion(float w, float x, float y, float z);  //   
    // ""    ...
    void ident();  //   .
    void scale(float s);  // .   -   .
    float norm();  //.
    float magnitude();  //.
    void StabilizeLength();  //    -    . 
    void normalize();   //.  ,     .
    //  ...
    void GetGLMatrix(GLfloat *matrix);  // OpenGL-    .
    void Mult(float W, float X, float Y, float Z);   //    ...
    void SetAxisAngle(float VecX, float VecY, float VecZ, float angle);  //     Axis-Angle .
    void RotateByAxisAngle(float VecX, float VecY, float VecZ, float angle);  //      (    ).

};

//---------------------------------------------------------------------------
#endif
